
 -- Algorithme Manipulation De 4 pattes
 -- utilisation de la classe Quadrupede, Chien, Cheval.
 --

------------ declaration des packages utilises
 with Ada.Text_IO; -- les entrees-sorties
 use Ada.Text_IO;
 
 with Ada.Strings.UnBounded;     -- les chaines de caracteres
 use Ada.Strings.UnBounded;
 
 with Quadrupede; use Quadrupede;    -- utilisation de la classe Quadrupede
 with Chien; use Chien;    -- utilisation de la classe Chien
 with Cheval; use Cheval;    -- utilisation de la classe Cheval
 
-------------
procedure Manipulation4pattes is 

 type T_Ptr_Chien is access T_Chien; -- Pointeur sur une Chien
 type T_Ptr_Cheval is access T_Cheval; -- Pointeur sur une Cheval

 package Strings renames Ada.Strings.Unbounded; -- pour gerer les chaines de caracteres

 package Entiers_Io is new Ada.Text_Io.Integer_Io ( Integer ); -- lire des Integer
 use Entiers_Io;

 chien1, chien2 : T_Ptr_Chien ;		-- declaration d'une instance "Chien" de la classe "Chien" 
 cheval1 : T_Ptr_Cheval ;

begin
-- attention : on ne peut pas declarer d'instance de la classe Quadrupede (elle est abstraite)

	-- creation effective d'un objet
	chien1 := new T_Chien;
	chien1.nom := Strings.To_Unbounded_String("medor");
	chien1.proprietaire := Strings.To_Unbounded_String("moi") ;

	chien2 := new T_Chien;
	chien2.nom := Strings.To_Unbounded_String("milou");
	chien2.proprietaire := Strings.To_Unbounded_String("tintin") ;

	cheval1 := new T_Cheval;
	cheval1.nom := Strings.To_Unbounded_String("pegase");
--	cheval1.proprietaire := Strings.To_Unbounded_String("tintin") ;


	typeDeCri(chien1.all);
	sonProprietaire(chien1.all);
	sonNom(chien1.all);
	Put( "nb de pattes :");Put(nombreDePattes(chien1.all));
	New_line;
	Put( "type :" ); decritType(chien1.all) ;
	New_line;

	typeDeCri(chien2.all);
	sonProprietaire(chien2.all);
	sonNom(chien2.all);
	Put( "nb de pattes :");Put(nombreDePattes(chien2.all));
	New_line;
	Put( "type :" ); decritType(chien2.all) ;
	New_line;

	typeDeCri(cheval1.all);
	sonTravail(cheval1.all);
	sonNom(cheval1.all);
	Put( "nb de pattes :");Put(nombreDePattes(cheval1.all));
	New_line;
	Put( "type :" ); decritType(cheval1.all) ;
	New_line;

end Manipulation4pattes;
